=== debian/changelog ===
qtrvsim (0.9.8-1) unstable; urgency=medium

  * Add gbp.conf
  * New upstream version 0.9.8
  * Drop adding-keywords.patch which appiled by upstream
  * Add 00-fix-spell.patch
  * Update qtrvsim_cli.1

 -- Bo YU <vimer@debian.org>  Wed, 12 Feb 2025 09:24:06 +0800

qtrvsim (0.9.7-1) unstable; urgency=low

  * Initial release. Closes: (Closes: #1068899)

 -- Bo YU <tsu.yubo@gmail.com>  Mon, 23 Sep 2024 16:50:05 +0800
