=== debian/control ===
Source: qtrvsim
Section: devel
Priority: optional
Maintainer: Bo YU <vimer@debian.org>
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 qtbase5-dev,
 libelf-dev,
 help2man,
Standards-Version: 4.7.0
Homepage: https://github.com/cvut/qtrvsim
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/vimerbf-guest/qtrvsim.git
Vcs-Browser: https://salsa.debian.org/vimerbf-guest/qtrvsim

Package: qtrvsim
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: RISC-V CPU simulator for education
 RISC-V CPU simulator for education purposes with pipeline and cache
 visualization.
