=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export QT_SELECT := qt5

include /usr/share/dpkg/pkg-info.mk
export DEB_VERSION_UPSTREAM

mandir := $(CURDIR)/debian/qtrvsim/usr/share/man/man1

%:
	dh $@ --buildsystem cmake

override_dh_auto_install:
	dh_auto_install
	mkdir -p $(mandir)
ifeq ($(DEB_HOST_GNU_TYPE), $(DEB_BUILD_GNU_TYPE))
	help2man $(CURDIR)/debian/qtrvsim/usr/bin/qtrvsim_cli --name="RISC-V CPU simulator for education" --version-string=$(DEB_VERSION_UPSTREAM) > $(mandir)/qtrvsim_cli.1
else
	install -m 644 $(CURDIR)/debian/manpage/qtrvsim_cli.1 $(mandir)
endif

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	ctest --test-dir $(CURDIR)/obj-$(DEB_HOST_GNU_TYPE);
endif
