=== debian/tests/control ===
#
# DEP-8: autopkgtest - automatic as-installed package testing
#        Please check * https://dep-team.pages.debian.net/deps/dep8/
#                     * /usr/share/doc/autopkgtest
#
# !!! Please make sure to edit this to a valid test, otherwise build will fails
#
#Tests: testcode.sh
#Restrictions: allow-stderr, breaks-testbed, needs-internet, needs-root

Tests: test
Depends: @,  gcc-riscv64-unknown-elf 
Restrictions: allow-stderr, needs-root
