=== debian/watch ===
version=4
https://github.com/cvut/qtrvsim/tags .*/v?@ANY_VERSION@\.tar\.gz
